// LogWindowView.cpp : implementation file
//

#include "stdafx.h"
#include "Log.h"
#include "TraceEvent.h"                                              // *** JMN
#include "Trace.h"                                                   // *** JMN
#include "LogWindowView.h"
#include "TraceNoteDlg.h"                                            // *** JMN

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

class TraceNote : public TraceComment
   {
   DECLARE_DYNAMIC(TraceNote)
    public:
      TraceNote(UINT id, CString s) : TraceComment(id, s) { }
      TraceNote(UINT id, UINT u) : TraceComment(id, u) { }
      virtual ~TraceNote() { }
      virtual COLORREF textcolor() { return RGB(255, 0, 255); }
   };
IMPLEMENT_DYNAMIC(TraceNote, TraceComment)

static UINT UWM_TRACE_CHANGE = ::RegisterWindowMessage(UWM_TRACE_CHANGE_MSG);// *** JMN

IMPLEMENT_DYNCREATE(CLogWindowView, CFormView)

/////////////////////////////////////////////////////////////////////////////
// CLogWindowView


CLogWindowView::CLogWindowView()
	: CFormView(CLogWindowView::IDD)
{
	//{{AFX_DATA_INIT(CLogWindowView)
	//}}AFX_DATA_INIT
}

CLogWindowView::~CLogWindowView()
{
}

void CLogWindowView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLogWindowView)
	DDX_Control(pDX, IDC_TODISK, c_ToDisk);
	DDX_Control(pDX, IDC_SETLIMIT, c_SetLimit);
	DDX_Control(pDX, IDC_TOP, c_ToTop);
	DDX_Control(pDX, IDC_PREV, c_PrevError);
	DDX_Control(pDX, IDC_NEXT, c_NextError);
	DDX_Control(pDX, IDC_LOG, c_Log);
	DDX_Control(pDX, IDC_LIMIT, c_Limit);
	DDX_Control(pDX, IDC_ENABLE_LIMIT, c_EnableLimit);
	DDX_Control(pDX, IDC_BOTTOM, c_ToBottom);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLogWindowView, CFormView)
	//{{AFX_MSG_MAP(CLogWindowView)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_NOTE, OnNote)
	ON_BN_CLICKED(IDC_PREV, OnPrev)
	ON_BN_CLICKED(IDC_TOP, OnTop)
	ON_BN_CLICKED(IDC_ENABLE_LIMIT, OnEnableLimit)
	ON_BN_CLICKED(IDC_BOTTOM, OnBottom)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_SETLIMIT, OnSetlimit)
	ON_LBN_SELCHANGE(IDC_LOG, OnSelchangeLog)
	ON_UPDATE_COMMAND_UI(IDM_LOGWINDOW, OnUpdateLogwindow)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT, OnUpdateEditCut)
	ON_COMMAND(ID_EDIT_CLEAR_ALL, OnEditClearAll)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR_ALL, OnUpdateEditClearAll)
	ON_COMMAND(ID_EDIT_CLEAR, OnEditClear)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR, OnUpdateEditClear)
	ON_BN_CLICKED(IDC_TODISK, OnTodisk)
	ON_COMMAND(ID_EDIT_SELECT_ALL, OnEditSelectAll)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SELECT_ALL, OnUpdateEditSelectAll)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT, OnUpdateFilePrint)
	ON_REGISTERED_MESSAGE(UWM_TRACE_CHANGE, OnTraceChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLogWindowView diagnostics

#ifdef _DEBUG
void CLogWindowView::AssertValid() const
{
	CFormView::AssertValid();
}

void CLogWindowView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CLogWindowView message handlers


/****************************************************************************
*			   CLogWIndowView::OnFileSave
* Result: void
*       
* Effect: 
*       Performs a File Save operation
****************************************************************************/

void CLogWindowView::OnFileSave() 
{
 c_Log.doSave(TRUE);
}

/****************************************************************************
*                      CLogWindowView::OnUpdateFileSave
* Inputs:
*       CCmdUI * pCmdUI: UI object
* Result: void
*       
* Effect: 
*       Enables/Disables the Save item. A Save requires a modification of
*	the control.
****************************************************************************/

void CLogWindowView::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(c_Log.canSave());
}

/****************************************************************************
*                        CLogWindowView::OnFileSaveAs
* Result: void
*       
* Effect: 
*       Performs as Save As
****************************************************************************/

void CLogWindowView::OnFileSaveAs() 
{
 c_Log.doSave(TRUE);	
}

/****************************************************************************
*                     CLogWindowView::OnUpdateFileSaveAs
* Inputs:
*       CCmdUI * pCmdUI: UI object
* Result: void
*       
* Effect: 
*       Enables/disables the Save As menu item
****************************************************************************/

void CLogWindowView::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(c_Log.canSaveAs());
}

/****************************************************************************
*                         CLogWindowView::OnFilePrint
* Result: void
*       
* Effect: 
*       Handles a Print menu item
****************************************************************************/

void CLogWindowView::OnFilePrint() 
{
 c_Log.Print();	
}

/****************************************************************************
*                           CLogWindowView::OnNext
* Result: void
*       
* Effect: 
*       Handles the > button being clicked
****************************************************************************/

void CLogWindowView::OnNext() 
{
 c_Log.toNext();
 updateControls();
}

/****************************************************************************
*                           CLogVinewoView::OnNote
* Result: void
*       
* Effect: 
*       Handles the Note button being clicked by prompting the use for a
*	note and adding a Note entry
****************************************************************************/

void CLogWindowView::OnNote() 
{
 CTraceNoteDlg dlg;
 if(dlg.DoModal() == IDOK)
    { /* note */
     dlg.m_Text.TrimRight();
     if(dlg.m_Text.GetLength() > 0)
	{ /* add comment */
	 c_Log.AddString(new TraceNote(TraceEvent::None, dlg.m_Text));
	} /* add comment */
    } /* note */
}

/****************************************************************************
*                           CLogWindowView::OnPrev
* Result: void
*       
* Effect: 
*       Handles the < button being clicked
****************************************************************************/

void CLogWindowView::OnPrev() 
{
 c_Log.toPrev();
 updateControls();
}

/****************************************************************************
*                            CLogWindowView::OnTop
* Result: void
*       
* Effect: 
*       Handles the << button being clicked
****************************************************************************/

void CLogWindowView::OnTop() 
{
 c_Log.toTop();
 updateControls();
}

/****************************************************************************
*                        CLogWindowView::OnEnableLimit
* Result: void
*       
* Effect: 
*       Handles the change in the EnableLimit button
****************************************************************************/

void CLogWindowView::OnEnableLimit() 
{
 c_Log.enableLimit(c_EnableLimit.GetCheck() == BST_CHECKED);
 updateControls();
}

/****************************************************************************
*                          CLogWIndowView::OnBottom
* Result: void
*       
* Effect: 
*       Handles the >> button being clicked
****************************************************************************/

void CLogWindowView::OnBottom() 
{
 c_Log.toEnd();
 updateControls();	
}


/****************************************************************************
*                       CLogWindowView::updateControls
* Result: void
*       
* Effect: 
*       Updates all the controls
****************************************************************************/

void CLogWindowView::updateControls()
    {
     c_ToTop.EnableWindow(c_Log.canTop());
     c_ToBottom.EnableWindow(c_Log.canEnd());
     c_NextError.EnableWindow(c_Log.canNext());
     c_PrevError.EnableWindow(c_Log.canPrev());
     BOOL enable = c_EnableLimit.GetCheck() == BST_CHECKED;
     c_SetLimit.EnableWindow(enable);
     c_Limit.EnableWindow(enable);
    } // CLogWindowView::updateControls

/****************************************************************************
*                           CLogWindowView::OnSize
* Inputs:
*       UINT nType: Type of resize
*	int cx: Width
*	int cy: Height
* Result: void
*       
* Effect: 
*       Resizes the child as well
****************************************************************************/

void CLogWindowView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	
	if(::IsWindow(c_Log.m_hWnd))                                 // *** JMN
	   { /* resize log */                                        // *** JMN
	    ResizeLog();                                             // *** JMN
	   } /* resize log */                                        // *** JMN
}


/****************************************************************************
*                          CLogWindowView::ResizeLog
* Result: void
*       
* Effect: 
*       Resizes the child log to fit the entire window
****************************************************************************/

void CLogWindowView::ResizeLog()                                     
    {                                                                
     CRect r;                                                        
     GetClientRect(&r);                                              
     CRect w;                                                        
     c_Log.GetWindowRect(&w);                                        
     ScreenToClient(&w);                                             
     c_Log.SetWindowPos(NULL, 0, 0, r.Width(), r.Height() - w.top,   
			SWP_NOMOVE | SWP_NOZORDER);                  
    } // CLogWindowView::ResizeLog                                   

/****************************************************************************
*                       CLogWindowView::OnInitialUpdate
* Result: void
*       
* Effect: 
*       Forces the log to expand to the correct size and sets the caption
****************************************************************************/

void CLogWindowView::OnInitialUpdate()                               
{                                                                    
	CFormView::OnInitialUpdate();                                
	ResizeLog();                                                 
	CString s;                                                   
	s.LoadString(IDS_TRACELOG_CAPTION);                          
	GetParent()->SetWindowText(s);                               
	updateControls();                                            
}                                                                    

/****************************************************************************
*                         CLogWindowView::OnSetlimit
* Result: void
*       
* Effect: 
*       Handles the "Set Limit" button by extracting the limit and
*	setting it in the log window.
****************************************************************************/

void CLogWindowView::OnSetlimit() 
{
 CString s;
 c_Limit.GetWindowText(s);
 int limit = _ttoi(s);
 if(limit == 0)
    return;
 c_Log.setLimit(limit);
 updateControls();
}

/****************************************************************************
*                       CLogWindowView::OnSelChangeLog
* Result: void
*       
* Effect: 
*       Forces the controls to update as a consequence of a change in
*	the selection list.
****************************************************************************/

void CLogWindowView::OnSelchangeLog() 
{
 updateControls();
}

/****************************************************************************
*                      CLogWindowView::OnUpdateLogwindow
* Inputs:
*       CCmudUI * UI: UI object
* Result: void
*       
* Effect: 
*       Always disables the "Create log" menu item, primarily to disable
*	the toolbar (since this class does not have an actual menu item)
* Notes:
*	This overrides the default handler, which always enables the item
****************************************************************************/

void CLogWindowView::OnUpdateLogwindow(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(FALSE);
}

/****************************************************************************
*                         CLogWindowView::OnEditCopy
* Result: void
*       
* Effect: 
*       Copies the selected items
****************************************************************************/

void CLogWindowView::OnEditCopy() 
{
 c_Log.Copy();
}

/****************************************************************************
*                      CLogWindowView::OnUpdateEditCopy
* Inputs:
*       CCmdUI * pCmdUI: UI object
* Result: void
*       
* Effect: 
*       Enables/disables the Copy menu item
****************************************************************************/

void CLogWindowView::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(c_Log.canCopy());
} 

/****************************************************************************
*                          CLogWindowView::OnEditCut
* Result: void
*       
* Effect: 
*       Cuts the selected items from the log list
****************************************************************************/

void CLogWindowView::OnEditCut() 
{
 c_Log.Cut();	
}

/****************************************************************************
*                       CLogWindowView::OnUpdateEditCut
* Inputs:
*       CCmdUI * pCmdUI: UI object
* Result: void
*       
* Effect: 
*       Enables the Cut menu item
****************************************************************************/

void CLogWindowView::OnUpdateEditCut(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(c_Log.canCut());
}

/****************************************************************************
*                       CLogWindowView::OnEditClearAll
* Result: void
*       
* Effect: 
*       Clears the entire contents of the log window
****************************************************************************/

void CLogWindowView::OnEditClearAll() 
{
 c_Log.ResetContent();
}

/****************************************************************************
*                    CLogWindowView::OnUpdateEditClearAll
* Inputs:
*       CCmdUI * pCmdUI: UI object
* Result: void
*       
* Effect: 
*       Enables/disbles the Clear All menu item
****************************************************************************/

void CLogWindowView::OnUpdateEditClearAll(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(c_Log.canClearAll());
}

/****************************************************************************
*		     CLogWindowView::CLogWindowOnEditClear
* Result: void
*       
* Effect: 
*       Implements the Clear (delete selection) operation
****************************************************************************/

void CLogWindowView::OnEditClear() 
{
 c_Log.Delete();	
}

/****************************************************************************
*                      CLogWindowView::OnUpdateEditClear
* Inputs:
*       CCmdUI * pCmdUI: UI object
* Result: void
*       
* Effect: 
*       Enables the Delete operation
****************************************************************************/

void CLogWindowView::OnUpdateEditClear(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(c_Log.canDelete());
}

/****************************************************************************
*                          CLogWindowView::OnToDisk
* Result: void
*       
* Effect: 
*       Responds to a change in the To Disk checkbox. If it is checked ON,
*	attempts to open the trace file. If this fails, clears the check box.
****************************************************************************/

void CLogWindowView::OnTodisk() 
{
 BOOL desired = c_ToDisk.GetCheck() == BST_CHECKED;
 BOOL result = c_Log.setToDisk(desired);
 if(desired && !result)
    c_ToDisk.SetCheck(BST_UNCHECKED);
}


/****************************************************************************
*                       CLogWindowView::OnEditSelectAll
* Result: void
*       
* Effect: 
*       Selects all the items in the control
****************************************************************************/

void CLogWindowView::OnEditSelectAll() 
{
 c_Log.SelectAll();	
}

/****************************************************************************
*		     CLogWindowView::OnUpdateEditSelectAll
* Inputs:
*       CCmdUI * pCmdUI: UI object
* Result: void
*       
* Effect: 
*       Enables/disables the Select All menu item
****************************************************************************/

void CLogWindowView::OnUpdateEditSelectAll(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(c_Log.canSelectAll());
}

/****************************************************************************
*		       CLogWindowView::OnUpdateFilePrint
* Inputs:
*       CCmdUI * pCmdUI: UI object
* Result: void
*       
* Effect: 
*       Enables/disables the Print menu item
****************************************************************************/

void CLogWindowView::OnUpdateFilePrint(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(c_Log.canPrint());
}

/****************************************************************************
*                          CLogWindowView::OnTraceChange
* Inputs:
*       WPARAM: ignored
*	LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Forces controls to update
****************************************************************************/

LRESULT CLogWindowView::OnTraceChange(WPARAM, LPARAM)
    {
     updateControls();
     return 0;
    } // CLogWindow::OnTraceChange

/****************************************************************************
*                          CLogWindowView::AddString
* Inputs:
*       TraceEvent * event: Event
* Result: int
*       Result of insertion
* Effect: 
*       Inserts the item into the child list
****************************************************************************/

int CLogWindowView::AddString(TraceEvent * event)
    {
     return c_Log.AddString(event);
    } // CLogWindowView::AddString
